<template>
  <svg xmlns="http://www.w3.org/2000/svg"
    viewBox="0 0 400 400"
    :width="width"
    :height="height"
    role="presentation"
  >
    <title
      id="circuit-icon"
      lang="en"
    >Water inlet type circuit icon</title> <!-- eslint-disable-line -->
    <g id="_water_group">
      <path
        id="_water"
        d="M250,220 V260"
        :stroke="fill"
        stroke-width="10"
        :opacity="status ? 1 : 0"
      />
    </g>
    <g id="_hexagon_group">
      <path
        id="_hexagon"
        d="M320,140 Q 320 130 310 124 M310,124 210,66 Q 200 60 190 66 M190,66 90,124 Q 80 130 80 140 M80,140 80,260 Q 80 270 90 276 M90,276 190,334 Q 200 340 210 334 M210,334 310,276 Q 320 270 320 260 M320,260 320,140"
        :stroke="fill"
        stroke-width="10"
        stroke-linejoin="round"
        stroke-linecap="round"
        fill="transparent"
      />
    </g>
    <g id="_faucet_group">
      <path
        id="_faucet"
        d="M140,180 H 220 Q 260 180, 260 220 H 240 Q 240 200, 220 200 H 140 Z"
        :stroke="fill"
        stroke-width="10"
        stroke-linejoin="round"
        stroke-linecap="round"
        :fill="fill"
      />
      <g id="_faucet_handle">
        <path
            id="_faucet_handle_top_animated"
            :class="statusClass"
            d="M180,150 H 220"
            :stroke="fill"
            stroke-width="10"
            stroke-linejoin="round"
            stroke-linecap="round"
        />
        <path
            id="_faucet_handle_bottom"
            d="M200,180 V 146"
            :stroke="fill"
            stroke-width="10"
            stroke-linejoin="round"
            stroke-linecap="round"
        />
      </g>
    </g>
  </svg>
</template>

<script>
// utils
import { debounce } from '#utils'
// BaseIcon
import BaseIcon from '@/components/commons/icons/BaseIcon'

/**
 * WaterInletTypeCircuit icon
 */
export default {
  name: 'WaterInletTypeCircuitIcon',
  extends: BaseIcon,
  data () {
    return {
      statusClass: ''
    }
  },
  props: {
    status: {
      type: Boolean,
      default: false
    }
  },
  watch: {
    status: function (to, from) {
      this.statusClass = ''
      if (from) {
        debounce(() => {
          this.statusClass = '_faucet-close'
        }, 100)()
      } else {
        debounce(() => {
          this.statusClass = '_faucet-open'
        }, 100)()
      }
    }
  }
}
</script>

<style lang="scss" scoped>

#_hexagon_group,
#_faucet_group,
#_water_group {
  transform-origin: center;
}

#_hexagon,
#_faucet,
#_faucet_handle_bottom,
#_faucet_handle_top_animated,
#_water {
  transition: fill 400ms, stroke 400ms;
}

#_water {
  transition: opacity 400ms 400ms;
  stroke-dasharray: 20;
  stroke-dashoffset: 0;
  animation: 300ms flow linear 0s reverse infinite none running;
}

._faucet-close {
  transform-origin: center;
  -webkit-animation: rotating 600ms linear;
  -moz-animation: rotating 600ms linear;
  -ms-animation: rotating 600ms linear;
  -o-animation: rotating 600ms linear;
  animation: rotating 600ms linear;
}

._faucet-open {
  transform-origin: center;
  -webkit-animation: rotating 600ms linear reverse;
  -moz-animation: rotating 600ms linear reverse;
  -ms-animation: rotating 600ms linear reverse;
  -o-animation: rotating 600ms linear reverse;
  animation: rotating 600ms linear reverse;
}

@keyframes flow {
  to {
    stroke-dashoffset: 40;
  }
}

@-moz-keyframes flow {
  to {
    stroke-dashoffset: 40;
  }
}

@-webkit-keyframes flow {
  to {
    stroke-dashoffset: 40;
  }
}

@-webkit-keyframes rotating {
  from {
    -webkit-transform: rotateY(0deg);
    -o-transform: rotateY(0deg);
    transform: rotateY(0deg);
  }

  to {
    -webkit-transform: rotateY(360deg);
    -o-transform: rotateY(360deg);
    transform: rotateY(360deg);
  }
}

@keyframes rotating {
  from {
    -ms-transform: rotateY(0deg);
    -moz-transform: rotateY(0deg);
    -webkit-transform: rotateY(0deg);
    -o-transform: rotateY(0deg);
    transform: rotateY(0deg);
  }

  to {
    -ms-transform: rotateY(360deg);
    -moz-transform: rotateY(360deg);
    -webkit-transform: rotateY(360deg);
    -o-transform: rotateY(360deg);
    transform: rotateY(360deg);
  }
}

</style>
